// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.25.0
// source: appointments.sql

package db

import (
	"context"
	"time"
)

const createAppointment = `-- name: CreateAppointment :one
INSERT INTO appointments (
    title,
    schedule,
    status,
    patient_id
) VALUES (
    $1, $2, $3, $4
) RETURNING id, title, schedule, status, updated_at, patient_id
`

type CreateAppointmentParams struct {
	Title     string    `json:"title"`
	Schedule  time.Time `json:"schedule"`
	Status    string    `json:"status"`
	PatientID int64     `json:"patient_id"`
}

func (q *Queries) CreateAppointment(ctx context.Context, arg CreateAppointmentParams) (Appointments, error) {
	row := q.db.QueryRowContext(ctx, createAppointment,
		arg.Title,
		arg.Schedule,
		arg.Status,
		arg.PatientID,
	)
	var i Appointments
	err := row.Scan(
		&i.ID,
		&i.Title,
		&i.Schedule,
		&i.Status,
		&i.UpdatedAt,
		&i.PatientID,
	)
	return i, err
}

const deleteAppointment = `-- name: DeleteAppointment :exec
DELETE FROM appointments WHERE id = $1
`

func (q *Queries) DeleteAppointment(ctx context.Context, id int64) error {
	_, err := q.db.ExecContext(ctx, deleteAppointment, id)
	return err
}

const getAppointment = `-- name: GetAppointment :one
SELECT id, title, schedule, status, updated_at, patient_id FROM appointments
WHERE id = $1 LIMIT 1
`

func (q *Queries) GetAppointment(ctx context.Context, id int64) (Appointments, error) {
	row := q.db.QueryRowContext(ctx, getAppointment, id)
	var i Appointments
	err := row.Scan(
		&i.ID,
		&i.Title,
		&i.Schedule,
		&i.Status,
		&i.UpdatedAt,
		&i.PatientID,
	)
	return i, err
}

const listAppointments = `-- name: ListAppointments :many
SELECT id, title, schedule, status, updated_at, patient_id FROM appointments
ORDER BY id
LIMIT $1
OFFSET $2
`

type ListAppointmentsParams struct {
	Limit  int64 `json:"limit"`
	Offset int64 `json:"offset"`
}

func (q *Queries) ListAppointments(ctx context.Context, arg ListAppointmentsParams) ([]Appointments, error) {
	rows, err := q.db.QueryContext(ctx, listAppointments, arg.Limit, arg.Offset)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Appointments
	for rows.Next() {
		var i Appointments
		if err := rows.Scan(
			&i.ID,
			&i.Title,
			&i.Schedule,
			&i.Status,
			&i.UpdatedAt,
			&i.PatientID,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const updateAppointment = `-- name: UpdateAppointment :exec
UPDATE appointments 
SET title = $2
WHERE id = $1
`

type UpdateAppointmentParams struct {
	ID    int64  `json:"id"`
	Title string `json:"title"`
}

func (q *Queries) UpdateAppointment(ctx context.Context, arg UpdateAppointmentParams) error {
	_, err := q.db.ExecContext(ctx, updateAppointment, arg.ID, arg.Title)
	return err
}
